unit MainUnit;
{ GRP
// 
SpriteCount: Word
PictureWidth: Word
PictureHeight: Word
//  
//   
OffsetLeft: Byte    //   +1
OffsetTop: Byte     //   +1
SpriteWidth: Byte
SpriteHeight: Byte
SpriteOffset: LongInt
//  
(8,9,A,B)10 -                         //  
(4,5,6,7)01 - ,   2-  //   
(0,1,2,3)00 - ,   2-  //    
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ExtCtrls, Gauges, Menus, ComCtrls, About;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Button1: TButton;
    Edit1: TEdit;
    CheckBox2: TCheckBox;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N5: TMenuItem;
    GroupBox3: TGroupBox;
    Edit2: TEdit;
    Button2: TButton;
    OpenDialog1: TOpenDialog;
    CheckBox1: TCheckBox;
    TrackBar1: TTrackBar;
    Timer1: TTimer;
    Label1: TLabel;
    Button3: TButton;
    CheckBox3: TCheckBox;
    GroupBox4: TGroupBox;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    SaveDialog1: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure FileListBox1DblClick(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure DriveComboBox1Click(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
    procedure DirectoryListBox1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  procedure LoadSpriteBase(GRPName: string);
  procedure LoadPalette;
  procedure DrawSprite(SIndex: Integer);
  function GetNameFromPath(s: string): string;
  procedure ExtractSprite(GRPName: string; SpriteIndex: Integer; UseSpriteSize: Boolean);
  function BuildStr(s: string; c: char; n: LongInt): string;
  procedure Expand(Source: Byte; var SType,SLength: Byte);
  function GetShortPath(s: string): string;
  function GetCharCount(s: string; c: char): Integer;
  function GetCharFirst(s: string; c: char): Integer;
  function GetCharLast(s: string; c: char): Integer;
  procedure SetAnimatorEnabled(b: Boolean);
  procedure SetAnimatorSpeed(i: Byte);

const
  TempFileName='Temp$$$.bmp';
  Product_Name='GRP Converter';
  Product_Version='v1.0';
  Product_Data='12.07.2001';
  Author_Name=' ';
  Author_EMail='termius@aport2000.ru';
  Author_http='termius.narod.ru';

var
  Form1: TForm1;
  CurDir, CurGRP, PalName: string;
  BGBitmap: TBitmap;
  BG: record
        Enabled: Boolean;
        GRPName: string;
        SpriteIndex: LongInt;
      end;
  Pal: ARRAY[0..255]OF RECORD
                         B,G,R,F: Byte;
                       END;
  ID: ARRAY[1..2]OF Char;
  TotalBitmaps, CurAnimSprite, AniMode: LongInt;
  BMPHeader: RECORD
               FullSize: LongInt;
               _H1: LongInt;
               _C1: LongInt;
               _C2: LongInt;
               X: LongInt;
               Y: LongInt;
               _C3: Word;
               _C4: Word;
               _H2: LongInt;
               _H3: LongInt;
               DataSize1: LongInt;     //DataSize=X*Y+2*Y
               DataSize2: LongInt;     //DataSize=X*Y+2*Y
               _C5: ARRAY[1..8]OF Byte;
             END;
  GRPHeader: record
               SpritesCount: Word;
               PictureWidth: Word;
               PictureHeight: Word;
               GRPType: Word;
             end;
  GRPBitmap: array[1..1000]of TBitmap;
  GRPSprite: array [1..1000] of record
                                  OffsetLeft: Byte;
                                  OffsetTop: Byte;
                                  SpriteWidth: Byte;
                                  SpriteHeight: Byte;
                                  SpriteOffset: LongInt;
                                end;

implementation

uses Preview, Waiting;

{$R *.DFM}

function GetCharFirst(s: string; c: Char): Integer;
begin
  GetCharFirst:=Pos(c,s);
end;

function GetCharLast(s: string; c: Char): Integer;
var
  i,t: Integer;
begin
  t:=0;
  if Length(s)=0 then t:=0 else
  for i:=1 to Length(s) do
  if s[i]=c then t:=i;
  GetCharLast:=t;
end;

function GetCharCount(s: string; c: char): Integer;
var
  i,t: Integer;
begin
  t:=0;
  if Length(s)=0 then t:=0 else
  for i:=1 to Length(s) do
  if s[i]=c then Inc(t);
  GetCharCount:=t;
end;

function GetShortPath(s: string): string;
begin
  if GetCharCount(s,'\')=0 then GetShortPath:=s else
  GetShortPath:=Copy(s,1,GetCharFirst(s,'\'))+'...'+Copy(s,GetCharLast(s,'\'),Length(s)-GetCharLast(s,'\')+1);
end;

procedure Expand(Source: Byte; var SType,SLength: Byte);
begin
{         }
  SType:=Source shr 6;
  SLength:=Source - (SType shl 6);
end;


function BuildStr(s: string; c: char; n: LongInt): string;
var
  t: string;
begin
  if Length(s)=n then
  begin
    BuildStr:=s;
    Exit;
  end;
  t:=s;
  While Length(t)<n do t:=c+t;
  BuildStr:=t;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ID[1]:='B';
  ID[2]:='M';
  BMPHeader._C1:=$00000436;
  BMPHeader._C2:=$00000028;
  BMPHeader._C3:=$0001;
  BMPHeader._C4:=$0008;
  BMPHeader._H2:=$00;
  BMPHeader._H3:=$00;
  TotalBitmaps:=0;
  BGBitmap:=TBitmap.Create;
  GetDir(0,CurDir);
  PalName:=CurDir+'\Palette.pal';
  CurAnimSprite:=0;
  SetAnimatorSpeed(6);
  LoadPalette;
end;

procedure ExtractSprite(GRPName: string; SpriteIndex: Integer; UseSpriteSize: Boolean);
var
  FGRP,FBMP: file;
  i,j,SSize: LongInt;
  Buffer,Result: array [1..256] of Char;
  SByte,SType,SLength,BottomOffset,RightOffset: Byte;
  RowOffset,TotalRowLength,Add: Word;
  TempChar: Char;
begin
  {***   }
  AssignFile(FGRP,GRPName);
  Reset(FGRP,1);
  AssignFile(FBMP,CurDir+'\'+TempFileName);
  Rewrite(FBMP,1);
  BlockWrite(FBMP,ID,2);
  if UseSpriteSize then
  begin
    BMPHeader.x:=GRPSprite[SpriteIndex].SpriteWidth;
    BMPHeader.y:=GRPSprite[SpriteIndex].SpriteHeight;
  end else
  begin
    BMPHeader.x:=GRPHeader.PictureWidth;
    BMPHeader.y:=GRPHeader.PictureHeight;
  end;
  if (Frac(BMPHeader.x/4)=0.25)then Add:=3 else
  if (Frac(BMPHeader.x/4)=0.5)then Add:=2 else
  if (Frac(BMPHeader.x/4)=0.75)then Add:=1 else Add:=0;
  BMPheader.DataSize1:=BMPHeader.x*BMPHeader.y;
  BMPheader.DataSize2:=BMPHeader.x*BMPHeader.y;
  BMPHeader.FullSize:=BMPHeader.DataSize1+$436;
  BMPHeader._H3:=BMPHeader.FullSize-$36;
  BlockWrite(FBMP,BMPHeader,SizeOf(BMPHeader));
  BlockWrite(FBMP,Pal,1024);
  if not UseSpriteSize then
  begin
    BottomOffset:=GRPHeader.PictureHeight-GRPSprite[SpriteIndex].SpriteHeight-GRPSprite[SpriteIndex].OffsetTop;
    RightOffset:=GRPHeader.PictureWidth-GRPSprite[SpriteIndex].SpriteWidth-GRPSprite[SpriteIndex].OffsetLeft;
  end;
  if GRPHeader.SpritesCount=1 then SSize:=FileSize(FGRP)-GRPSprite[1].SpriteOffset else SSize:=GRPSprite[2].SpriteOffset-GRPSprite[1].SpriteOffset;
  if GRPHeader.GRPType=0 then
  if (SSize=0)or(SSize=GRPSprite[1].SpriteWidth*GRPSprite[1].SpriteHeight) then GRPHeader.GRPType:=0 else GRPHeader.GRPType:=1
  else GRPHeader.GRPType:=1;
  if not UseSpriteSize then
  if BottomOffset>0 then
  for i:=1 to BottomOffset do
  begin
    FillChar(Result,GRPHeader.PictureWidth,#$00);
    BlockWrite(FBMP,Result,GRPHeader.PictureWidth);
  end;
  for i:=GRPSprite[SpriteIndex].SpriteHeight downto 1 do
  begin
    Seek(FGRP,GRPSprite[SpriteIndex].SpriteOffset+(i-1)*2);
    BlockRead(FGRP,RowOffset,2);
    Seek(FGRP,GRPSprite[SpriteIndex].SpriteOffset+RowOffset);
    TotalRowLength:=0;
    if GRPHeader.GRPType=0 then
    begin
      Seek(FGRP,GRPSprite[SpriteIndex].SpriteOffset+(i-1)*GRPSprite[SpriteIndex].SpriteWidth);
      BlockRead(FGRP,Result,GRPSprite[SpriteIndex].SpriteWidth);
      TotalRowLength:=GRPSprite[SpriteIndex].SpriteWidth;
    end
    else
    while TotalRowLength<GRPSprite[SpriteIndex].SpriteWidth do
    begin
      BlockRead(FGRP,SByte,1);
      Expand(SByte,SType,SLength);
      case SType of
        $00: begin
               BlockRead(FGRP,Buffer,SLength);
               for j:=1 to SLength do Result[TotalRowLength+j]:=Buffer[j];
             end;
        $01: begin
               BlockRead(FGRP,Buffer,1);
               for j:=1 to SLength do Result[TotalRowLength+j]:=Buffer[1];
             end;
        $02: begin
               for j:=1 to SLength do Result[TotalRowLength+j]:=#$00;
             end;
        $03: begin
               SLength:=SLength or $40;
               for j:=1 to SLength do Result[TotalRowLength+j]:=#$00;
             end;
      end;
      TotalRowLength:=TotalRowLength+SLength;
    end;
    if GRPHeader.GRPType=0 then
    for j:=1 to GRPSprite[SpriteIndex].SpriteWidth div 2 do
    begin
      TempChar:=Result[j];
      Result[j]:=Result[GRPSprite[SpriteIndex].SpriteWidth-j+1];
      Result[GRPSprite[SpriteIndex].SpriteWidth-j+1]:=TempChar;
    end;
    if not UseSpriteSize then
    if GRPSprite[SpriteIndex].OffsetLeft>0 then
    begin
      FillChar(Buffer,GRPSprite[SpriteIndex].OffsetLeft,#$00);
      BlockWrite(FBMP,Buffer,GRPSprite[SpriteIndex].OffsetLeft);
    end;
    BlockWrite(FBMP,Result,GRPSprite[SpriteIndex].SpriteWidth+Add);
    if not UseSpriteSize then
    if RightOffset>0 then
    begin
      FillChar(Buffer,RightOffset,#$00);
      BlockWrite(FBMP,Buffer,RightOffset);
    end;
  end;
  if not UseSpriteSize then
  if GRPSprite[SpriteIndex].OffsetTop>0 then
  for i:=1 to GRPSprite[SpriteIndex].OffsetTop do
  begin
    FillChar(Result,GRPHeader.PictureWidth,#$00);
    BlockWrite(FBMP,Result,GRPHeader.PictureWidth);
  end;
  CloseFile(FBMP);
  CloseFile(FGRP);
  {***   }
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  SetAnimatorEnabled(False);
  Button1.Enabled:=True;
  Button3.Enabled:=True;
  Button4.Enabled:=True;
  Button5.Enabled:=True;
  Button6.Enabled:=True;
  DrawSprite(ListBox1.ItemIndex+1);
end;

procedure LoadSpriteBase(GRPName: string);
var
  FGRP: file;
  i: LongInt;
begin
  {***   }
  AssignFile(FGRP,GRPName);
  Reset(FGRP,1);
  BlockRead(FGRP,GRPHeader,8);
  Seek(FGRP,$06);
  Form1.ListBox1.Items.Clear;
  for i:=1 to GRPHeader.SpritesCount do
  begin
    BlockRead(FGRP,GRPSprite[i],8);
    Form1.ListBox1.Items.Add(BuildStr(IntToStr(i),'0',3)+':('+BuildStr(IntToStr(GRPHeader.PictureWidth),'0',3)+'x'+BuildStr(IntToStr(GRPHeader.PictureHeight),'0',3)+')');
  end;
  Form1.ListBox1.Repaint;
  CloseFile(FGRP);
  {***   }
  {***    }
  Form4.Show;
  Form4.Gauge1.MaxValue:=GRPHeader.SpritesCount;
  Form4.Gauge1.MinValue:=0;
  if TotalBitmaps>0 then
  for i:=1 to TotalBitmaps do GRPBitmap[i].Free;
  for i:=1 to GRPHeader.SpritesCount do
  begin
    Form4.Gauge1.Progress:=i;
    Form4.Gauge1.Repaint;
    ExtractSprite(GRPName,i,not Form1.CheckBox1.Checked);
    GRPBitmap[i]:=TBitmap.Create;
    GRPBitmap[i].LoadFromFile(CurDir+'\'+TempFileName);
  end;
  Form4.Hide;
  TotalBitmaps:=GRPHeader.SpritesCount;
  Form4.Gauge1.Progress:=0;
  {***    }
end;

procedure TForm1.FileListBox1DblClick(Sender: TObject);
begin
  Form2.Hide;
  CurGRP:=FileListBox1.FileName;
  LoadSpriteBase(FileListBox1.FileName);
end;

procedure TForm1.N2Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  SetAnimatorEnabled(False);
  BG.Enabled:=True;
  BG.GRPName:=CurGRP;
  BG.SpriteIndex:=ListBox1.ItemIndex+1;
  BGBitmap.Width:=GRPBitmap[ListBox1.ItemIndex+1].Width;
  BGBitmap.Height:=GRPBitmap[ListBox1.ItemIndex+1].Height;
  GRPBitmap[ListBox1.ItemIndex+1].Transparent:=False;
  BGBitmap.Canvas.CopyRect(Rect(0,0,GRPBitmap[ListBox1.ItemIndex+1].Width,GRPBitmap[ListBox1.ItemIndex+1].Height),GRPBitmap[ListBox1.ItemIndex+1].Canvas,Rect(0,0,GRPBitmap[ListBox1.ItemIndex+1].Width,GRPBitmap[ListBox1.ItemIndex+1].Height));
  Edit1.Text:=GetShortPath(BG.GRPName)+':(#'+BuildStr(IntToStr(BG.SpriteIndex),'0',3)+')';
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  Form2.Left:=Form1.Left+2+280;
  Form2.Top:=Form1.Top+4+32;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    PalName:=OpenDialog1.FileName;
    LoadPalette;
  end;
end;

procedure LoadPalette;
var
  FPal: file;
  i: Integer;
begin
  {***   }
  if FileExists(PalName)then
  begin
    AssignFile(FPAL,PalName);
    Reset(FPAL,1);
    if FileSize(FPal)<>768 then
    begin
      MessageDlg('   "'+GetShortPath(PalName)+'".  ',mtError,[mbOk],0);
      PalName:='';
    end else
    for i:=0 to 255 do
    begin
      BlockRead(FPAL,Pal[i].B,1);
      BlockRead(FPAL,Pal[i].G,1);
      BlockRead(FPAL,Pal[i].R,1);
      Pal[i].F:=$00;
    end;
    CloseFile(FPAL);
  end else
  begin
    MessageDlg('   "'+GetShortPath(PalName)+'".   ',mtError,[mbOk],0);
    PalName:='';
  end;
  Form1.Edit2.Text:=GetShortPath(PalName);
  {***   }
end;

procedure SetAnimatorEnabled(b: Boolean);
begin
  Form1.Timer1.Enabled:=b;
end;

procedure SetAnimatorSpeed(i: Byte);
var
  ti: Integer;
begin
  ti:=i;
  if ti<1 then ti:=1;
  if ti>10 then ti:=10;
  Form1.Timer1.Interval:=(10-ti+1)*20;
  Form1.TrackBar1.Position:=ti;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  SetAnimatorSpeed(TrackBar1.Position);
end;

procedure DrawSprite(SIndex: Integer);
begin
  {***    }
  Form2.Image1.Picture.Bitmap.Width:=0;
  Form2.Image1.Picture.Bitmap.Height:=0;
  Form2.Image1.Picture.Bitmap.Width:=GRPBitmap[SIndex].Width;
  Form2.Image1.Picture.Bitmap.Height:=GRPBitmap[SIndex].Height;
  {***  }
  if (BG.Enabled)and(Form1.CheckBox2.Checked) then
  begin
    Form2.Image1.Picture.Bitmap.Canvas.Brush.Style:=bsClear;
    Form2.Image1.Picture.Bitmap.Canvas.Brush.Bitmap:=BGBitmap
  end
  else Form2.Image1.Picture.Bitmap.Canvas.Brush.Style:=bsClear;
  {***  }
  if (BG.Enabled)and(Form1.CheckBox2.Checked) then Form2.Image1.Picture.Bitmap.Canvas.BrushCopy(Rect(0,0,GRPBitmap[SIndex].Width,GRPBitmap[SIndex].Height),GRPBitmap[SIndex],Rect(0,0,GRPBitmap[SIndex].Width,GRPBitmap[SIndex].Height),clBlack) else Form2.Image1.Picture.Bitmap.Canvas.CopyRect(Rect(0,0,GRPBitmap[SIndex].Width,GRPBitmap[SIndex].Height),GRPBitmap[SIndex].Canvas,Rect(0,0,GRPBitmap[SIndex].Width,GRPBitmap[SIndex].Height));
  Form2.ClientWidth:=Form2.Image1.Picture.Bitmap.Width;
  Form2.ClientHeight:=Form2.Image1.Picture.Bitmap.Height;
  {***    }
  if not Form2.Visible then Form2.Show;
end;

procedure TForm1.DriveComboBox1Click(Sender: TObject);
begin
  SetAnimatorEnabled(False);
end;

procedure TForm1.FileListBox1Click(Sender: TObject);
begin
  SetAnimatorEnabled(False);
end;

procedure TForm1.DirectoryListBox1Click(Sender: TObject);
begin
  SetAnimatorEnabled(False);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if GRPHeader.SpritesCount<1 then Exit;
  if not CheckBox3.Checked then
  begin
    if CurAnimSprite+1<=GRPHeader.SpritesCount then
      Inc(CurAnimSprite) else CurAnimSprite:=1;
    DrawSprite(CurAnimSprite);
  end
  else
  if ListBox1.SelCount>0 then
  begin
    if CurAnimSprite+1<=GRPHeader.SpritesCount then
      Inc(CurAnimSprite) else CurAnimSprite:=1;
    While not ListBox1.Selected[CurAnimSprite-1] do
    if CurAnimSprite+1<=GRPHeader.SpritesCount then
      Inc(CurAnimSprite) else CurAnimSprite:=1;
    DrawSprite(CurAnimSprite);
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if Timer1.Enabled then
  begin
    Timer1.Enabled:=False;
    Button3.Caption:='';
  end else
  begin
    Timer1.Enabled:=True;
    CurAnimSprite:=1;
    Button3.Caption:='';
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  ts: string;
begin
  if SaveDialog1.Execute then
  begin
    DrawSprite(ListBox1.ItemIndex+1);
    ts:=SaveDialog1.FileName;
    if GetCharFirst(GetNameFromPath(ts),'.')=0 then ts:=ts+'.bmp';
    Form2.Image1.Picture.Bitmap.SaveToFile(ts);
  end;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  MessageDlg(',     !',mtError,[mbOk],0);
end;

function GetNameFromPath(s: string): string;
var
  ts: string;
begin
  if GetCharCount(s,'\')=0 then ts:=s else
  ts:=Copy(s,GetCharLast(s,'\')+1,Length(s)-GetCharLast(s,'\'));
  GetNameFromPath:=ts;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  MessageDlg(',     !',mtError,[mbOk],0);
end;

procedure TForm1.N5Click(Sender: TObject);
begin
  ShowAbout(Product_Name,Product_Version,Product_Data,Author_Name,Author_EMail,Author_http);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DeleteFile(CurDir+'\'+TempFileName);
end;

end.
